#ifndef KERNEL_H
#define KERNEL_H

#include "mtask.h"

#define CLOCKIRQ	0				// Timer IRQ
#define quad(n)		((n) & ~3)

/* Kernel globals */

/* kernel.c */

extern Task_t *		mt_curr_task;
extern unsigned		mt_cs, mt_ds, mt_es, mt_fs, mt_gs;

/* queue.c */

void				mt_enqueue(Task_t *task, TaskQueue_t *queue);
void				mt_dequeue(Task_t *task);
Task_t *			mt_peeklast(TaskQueue_t *queue);
Task_t *			mt_getlast(TaskQueue_t *queue);

void				mt_enqueue_time(Task_t *task, Time_t ticks);
void				mt_dequeue_time(Task_t *task);
Task_t *			mt_peekfirst_time(void);
Task_t *			mt_getfirst_time(void);

/* irq.c */

extern unsigned 	mt_int_level;
void 				mt_setup_irqs(void);
void 				mt_restore_irqs(void);

/* math.c */

void				mt_setup_math(void);
void				mt_init_math(Task_t *task);
void				mt_save_math(Task_t *task);
void				mt_restore_math(Task_t *task);

#endif

